<?php
// $Id: opensearch.utils.inc,v 1.1 2009/02/21 03:23:43 cfuller12 Exp $

/**
 * @file
 * Common Utility Functions for opensearch
 *
 */

/**
 * Process opensearch XML.
 * $xml opensearch response XML. 
 * $xpath xpath expression.
 */
function opensearch_utils_process_opensearch_xml($xml, $xpath) {

	try {
		$opensearch_service = new SimpleXMLElement($xml);
	} catch (Exception $e) {
		drupal_set_message("Bad XML return");
		drupal_set_message($xml);

		return FALSE;
	}

	$opensearch_service->registerXPathNamespace('opensearch', 'http://a9.com/-/spec/opensearch/1.1/');
	$opensearch_service->registerXPathNamespace('D', 'http://www.w3.org/2005/Atom');
	$opensearch_service->registerXPathNamespace('alf', 'http://www.alfresco.org/opensearch/1.0/');
	$opensearch_service->registerXPathNamespace('relevance', 'http://a9.com/-/opensearch/extensions/relevance/1.0/');

	$entry = $opensearch_service->xpath($xpath);

	return $entry;
}

/**
 * Get XML node value.
 * $entry opensearch XML Node. 
 * $xpath xpath expression.
 */
function opensearch_utils_opensearch_xml_get_value($entry, $xpath) {
	$value = $entry->xpath($xpath);
	return $value[0][0];
}